
/*

Arduino  bluetooth Crane 2 wireless protocol.... 
Note: You will need to  purchase two HM-10 modules (one reciever, one transmitter).
  You must follow the video tutorial to find ensure that the recieving end works (with android app), Set Baud to 115200 and capture the MAC address of the reciever. 
  Program the transmitting HM-10 to also have 115200 baud rate, and use AT commands (AT+ROLE1) to set it to master mode, also (AT+CO[0][slave MAC Address]) to force it to connect to that device.


This code reuqires the Encoder library and FASTCRC library (links in the instructables). 
https://www.arduino.cc/reference/en/libraries/encoder/

https://github.com/FrankBoesing/FastCRC



*******************************************READ THIS*************************************
This code assumes the following:

1. A potentiometer is wired to the A2 anaolog pin of the arduino to act as a sensitivity setter for speed. 
2. 3 push buttons are wired to the arduino with pulldown resisitors (Digital pins 11, 12, and 13)  these can be changed to your will. 
3. The TX pin is wired to pull-down resisitors to make the TX line to the HM-10 a 3.3v signal
4. A rotary Encoder is wired to Pins 5 (DT) and 6 (CLK).  The switch of the encoder (SW) controls the direction toggle of the motor (switch wired to Pin 7). 
5. The arduino is using 5v as a source (5v is required by the Encoder and the HM-10 to properly power them). 

A wiring diagram will be on the instructables page. 
https://www.instructables.com/35-Wireless-Follow-Focus-From-the-Crane-2/ 

*/


#include <FastCRC.h> //xmodemcrc shit
#include <FastCRC_cpu.h> //xmodemcrc shit
#include <FastCRC_tables.h> //xmodemcrc shit


////////IGNORE THESE///////////
//#include <pgmspace.h>
//#define ENCODER_DO_NOT_USE_INTERRUPTS
///////////////////////////////



#include <Encoder.h> //encoder 

Encoder myEnc(5, 6);


//////////////////////////////////IGNORE THESE///////////////////////////
//#include <SoftwareSerial.h>
//USE IF FEATHER 
//Feather only 
//#if defined(ARDUINO_SAMD_ZERO) && defined(SERIAL_PORT_USBVIRTUAL)
  // Required for Serial on Zero based boards
//  #define Serial SERIAL_PORT_USBVIRTUAL
//#endif
//#define Serial Serial1
//////////////////////////////////////////////////////////////////////////



FastCRC16 CRC16;   //xmodemcrc shit

//create class for testdata to get parsed later 
union TESTDATA { 
  uint16_t data_01;
  struct {
    uint8_t data_0;
    uint8_t data_1;
  };
};
union TESTDATA testdata;  //end testdata


//Sample Packages to begin with 
uint8_t buf[13] = {0xA5, 0x5A, 0x0A, 0xFF, 0x0F, 0x00, 0x08, 0x00, 0x08,0x00, 0x47, 0x00,  0x00};
uint8_t buf2[15] = {0xA5, 0x5A, 0x0A, 0xFF, 0x0F, 0x00, 0x08, 0x00, 0x08,0x00, 0x47, 0x00,  0x00};
uint8_t crc[2];
byte messagestat[] = {0xA5, 0x5A, 0x4F, 0x71, 0x0A, 0xA0, 0x81, 0x00, 0x71, 0x68, 0xA0, 0x00, 0x00, 0x71, 0x6A, 0xA0, 0x01, 0x00, 0x9F, 0xB3};
uint8_t messageA[10] = {0xA5, 0x5A, 0x45, 0x71, 0x40, 0xE0, 0x02, 0x00, 0x87,0xE1};
uint8_t messageB[10] = {0xA5, 0x5A, 0x45, 0x71, 0x40, 0xE0, 0x03, 0x00, 0xB6,0xD2};
uint8_t messageC[10] = {0xA5, 0x5A, 0x45, 0x71, 0x40, 0xE0, 0x04, 0x00, 0x21,0x4B};

int potval;
uint8_t sendval;
//test 
uint8_t sendQ;

int pin= A0; //AnalogRead Pin

int loopnum = 0;


//Buttons on board
//top button  11,  clear 
//bottom right, 12,  B set 
//bottom  left, 13, A set 
const int buttonPinA = 13;
const int buttonPinB = 12;
const int buttonPinC = 11;
const int buttonPinPot = 7;
const int sensPot = A2; 

//int counterA = 0;
//int counterB = 0;
//int counterC = 0; 
bool messageFlag = false;
bool messageFlagA = false; 
bool messageFlagB = false; 
bool messageFlagC = false;  
bool pushFlagA = false; 
bool pushFlagB = false; 
bool pushFlagC = false;  
bool potPinFlag = false;
bool positiveMotion = false; 

//timing 
//int time0= 0;
long timesent=0;
long timepassed=0;


 
void setup() {
  delay(1500);
  Serial.begin(115200); //xmodemcrc shit
  pinMode(buttonPinA, INPUT);   // Set A stop button
  pinMode(buttonPinB, INPUT);   // Set B stop button
  pinMode(buttonPinC, INPUT);   // Set Clear Stops button
  pinMode(buttonPinPot,INPUT);  // Set direction button (push button in the encoder) 

}



long calPosition  = -99999;  //Made this big so it can avoid rolling over 0 and confusing the direction of motor
long oldPosition = 0; 
int sensitivity = 3; 







void loop() { 
  
  //Read a encoder current position          
  long newPos = myEnc.read();   

//Calculate a position based on direction setting   
if (positiveMotion == true){
  calPosition = calPosition + ((newPos-oldPosition)*sensitivity/100); 
  //calPosition = calPosition + ((newPos-oldPosition)/4); 
  }
else {
    calPosition = calPosition - ((newPos-oldPosition)*sensitivity/100) ;                  //all of this math needs looked at........ maybe a previous sent value can contritbute???????? fukkkkkkkk
    //calPosition = calPosition - ((newPos-oldPosition)/4);
    }
     
oldPosition = newPos;  


//time dependancy thing for later 
timepassed = millis() - timesent;


//Read the senstivity setting for next go 
sensitivity = map(analogRead(sensPot), 0, 1023, 100, 2800);   // Maps sensitivity between 100 and 700,  eventually translates to 1x or 7x speeds, read from the potentiometer. was 100 to 700
 


////////////Check if any of the buttons were pushed for Stop functions ////////////////////////////////////
if (digitalRead(buttonPinA) == HIGH && messageFlag == false){
      pushFlagA = true; 
}
if (digitalRead(buttonPinB) == HIGH && messageFlag == false){
      pushFlagB = true;      
}
if (digitalRead(buttonPinC) == HIGH && messageFlag == false){
      pushFlagC = true;     
}

if (digitalRead(buttonPinPot) == LOW && potPinFlag == false){
      potPinFlag = true;     
      //Serial.println("POT HIGH");
}

if (digitalRead(buttonPinA) == LOW && pushFlagA == true){
      pushFlagA = false; 
      messageFlag = true;
      messageFlagA = true;      
}
if (digitalRead(buttonPinB) == LOW && pushFlagB == true){
      pushFlagB = false;
      messageFlag = true;
      messageFlagB = true;      
}
if (digitalRead(buttonPinC) == LOW && pushFlagC == true){
      pushFlagC = false;
      messageFlag = true;
      messageFlagC = true;      
}
if (digitalRead(buttonPinPot) == HIGH && potPinFlag == true){
      potPinFlag = false; 
      //Serial.println("POT lOW AGAIN");//TODO: reverse the direction of the position valuse 
      positiveMotion = !positiveMotion; //flips the motion boolean...          
}
//////////////////////////////////////////////////////////////////////////////////////////////////








    
//START OF TIME DEPENDANCY, this transmits the appropriate packets over Serial roughly every 20 milliseconds. 
if (timepassed >= 19){


  //If a command is needed to be sent, rather than position packet. 
  if (messageFlag == false){   
    sendval = (uint8_t)((abs(calPosition)) >> 2); //loopnum or position
    sendQ = (uint8_t)((abs(calPosition)) << 6 );

    ///////////////////////////////////////Create the Package  ///////////////////////////////////
    buf[10] = sendval;
    buf2[10] = sendval; 
    buf[11] = sendQ; //test
    buf2[11] = sendQ; //test

    ///////////////////////////////CRC SEAL THAT SHIT /////////////////////////////
  
    //DEBUG see output Serial.println( CRC16.xmodem(buf, sizeof(buf)), HEX );  //once said CRC16.ccitt
      testdata.data_01 = CRC16.xmodem(buf, sizeof(buf));
    //DEBUG  Serial.println( testdata.data_0, HEX );  //display the two vals 
    //DEBUG  Serial.println( testdata.data_1, HEX );
  
      buf2[14]=testdata.data_1;  //Sepearate the variables and put them into the package
      buf2[13]=testdata.data_0;  //this wil be the second



      ///////////////////////////////////////Send the package ///////////////////////////////////

      //DISABLE THIS FOR DEBUG
      Serial.write(buf2, sizeof(buf2));  //Send the package 
      ///////////////////////////////////////////////////////////////////////////////////////////


      
      
      /////////////////////////////////////////DEBUGGING OVER SERIAL/////////////////
      //Serial.println(sensitivity);
      //Serial.println((int)newPos); 
      //Serial.println((int)oldPosition);
      //Serial.println((int)calPosition); 
      //Serial.print((int)sendval);
      //Serial.print(" + "); 
      //Serial.println((int)sendQ);
      //delay(20);
      //delayMicroseconds(18700);
       /////////////////////////////////////////DEBUGGING OVER SERIAL/////////////////
  }

    else { 
               
    if (messageFlagA == true){
      Serial.write(messageA, sizeof(messageA)); //send message A
      //Serial.println("SEND COMMAND A"); //DEBUG 
      messageFlagA = false; // reset flagA 
      messageFlag =false;  // reset master flag
      }
    else if  (messageFlagB == true) {
      Serial.write(messageB, sizeof(messageB)); //send message B
      //Serial.println("SEND COMMAND B"); //DEBUG 
      messageFlagB = false; // reset flagB 
      messageFlag =false;  // reset master flag
      }
     else if  (messageFlagC == true) {
      Serial.write(messageC, sizeof(messageC));//send message C
      //Serial.println("SEND COMMAND C");  //DEBUG 
      messageFlagC = false; // reset flagC 
      messageFlag =false;  // reset master flag
      }
              
      }

//Mark the time of sending packet for next calculation
timesent = millis(); 


}//end of time sent looper 


//general throttling, roughly 1 millisecond.
delayMicroseconds(5);

} // End of LOOP function



///END OF CODE 